#ifndef BUILDER_ATTRIBUTE_H_
#define BUILDER_ATTRIBUTE_H_

#include <iostream>
#include <memory>

namespace builder {

class Integer {
 public:
  Integer(int value);
  Integer(int64_t value);
  class Impl;

 private:
  std::shared_ptr<Impl> impl_;
};

class Array {
 public:
  class Impl;
  std::shared_ptr<Impl> GetImpl() { return impl_; }

 private:
  std::shared_ptr<Impl> impl_;
};

class Type {
 public:
  class Impl;
  std::shared_ptr<Impl> GetImpl() { return impl_; }

 private:
  std::shared_ptr<Impl> impl_;
};

// template <typename T>
// class DenseIntElementsAttr {
//  public:
//   explicit DenseIntElementsAttr(Tensor);
//   class Impl;
//   std::shared_ptr<Impl> GetImpl() { return impl_; }

//  private:
//   std::shared_ptr<Impl> impl_;
// };

}  // namespace builder

#endif