#ifndef BUILDER_TENSOR_
#define BUILDER_TENSOR_

#include <iostream>
#include <memory>

#include "PrimitiveType.h"
#include "Shape.h"

namespace builder {

class Tensor {
 public:
  Tensor(Shape& shape, PrimitiveType& primitiveType);
  class Impl;
  std::shared_ptr<Impl> GetImpl() { return impl_; }
  Shape GetShape();
  PrimitiveType GetType();

 private:
  std::shared_ptr<Impl> impl_;
};
}  // namespace builder

#endif