#ifndef BUILDER_TENSORIMPL_
#define BUILDER_TENSORIMPL_

#include "Builder.h"
#include "PrimitiveType.h"
#include "Shape.h"
#include "llvm/Support/Casting.h"
#include "mlir/IR/Attributes.h"
#include "mlir/IR/Builders.h"
#include "mlir/IR/MLIRContext.h"
#include "mlir/IR/Operation.h"
#include "mlir/IR/Types.h"
#include "mlir/IR/Value.h"

namespace builder {

class Tensor::Impl {
 public:
  Impl() = default;
  Impl(Shape& shape, PrimitiveType& primitiveType)
      : shape_(shape), primitiveType_(primitiveType) {}
  Shape GetShape() { return shape_; }
  PrimitiveType GetType() { return primitiveType_; }

 private:
  Shape shape_;
  PrimitiveType primitiveType_;
};

}  // namespace builder

#endif